#include <nds.h>
#include <fat.h>
#include <stdio.h>
#include <malloc.h>
#include <math.h>
	#include "screenshot.h"

#define DISTANCE 4


typedef struct
{
	int sX;
	int sY;
	u8* map;
}map;


map carte;
int compteur=0,Vbl_compteur=0,FPS=0;
int32 lookX = 0, lookY = 0, angle = 90;


int DrawGLScene();
void LoadWorld();
void Vbl_func()
{
	if(Vbl_compteur==60)
	{
		FPS=compteur;
		Vbl_compteur=0;
		compteur=0;
	}
	
	Vbl_compteur++;
}


int main()
{	
	// Turn on everything
	powerON(POWER_ALL);

	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);
	vramSetMainBanks(VRAM_A_TEXTURE, VRAM_B_LCD, VRAM_C_SUB_BG, VRAM_D_LCD);
	
	// IRQ basic setup
	irqInit();
		irqSet(IRQ_VBLANK, Vbl_func);
		irqEnable(IRQ_VBLANK);
	
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	// initialize the geometry engine
	glInit();
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(16,16,31,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);

	// Set our viewport to be the same size as the screen
	glViewport(0,0,255,191);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70, 256.0 / 192.0, 0.1, 100);
	
	// Set the current matrix to be the model matrix
	glMatrixMode(GL_MODELVIEW);
	
	//ds specific, several attributes can be set here	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_NONE | POLY_FORMAT_LIGHT0| POLY_FORMAT_LIGHT1| POLY_FORMAT_LIGHT2);
	
	fatInitDefault();
	
	LoadWorld();
	
	while (1) 
	{
		glColor3f(0.5, 0.5, 0.5);
		
		// draw the scene
		DrawGLScene();
		
		// flush to screen	
		glFlush(0);
		
		// wait for the screen to refresh
		swiWaitForVBlank();
			if(compteur == 0)
				iprintf("%d\n", FPS);
			compteur++;
		
		scanKeys();
		if(keysDown() & KEY_START)
			screenshot("shot.bmp");
		
		if(keysHeld() & KEY_UP || keysHeld() & KEY_X)
			lookY -= 256;
		if(keysHeld() & KEY_DOWN || keysHeld() & KEY_B)
			lookY += 256;
		if(keysHeld() & KEY_LEFT || keysHeld() & KEY_Y)
			lookX -= 256;
		if(keysHeld() & KEY_RIGHT || keysHeld() & KEY_A)
			lookX += 256;
		if(keysHeld() & KEY_L)
		{
			angle++;
			if(angle > 360)
				angle = 0;
		}
		if(keysHeld() & KEY_R)
		{
			angle--;
			if(angle < 0)
				angle = 360;
		}
	}
	
	return 0;
}

int DrawGLScene()											// Here's Where We Do All The Drawing
{
	u8 x, y;
	/*ds does this automagicaly*///glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();
	gluLookAtf32(	lookX + DISTANCE * floattof32((float)cos(angle*M_PI/180)), //position X
					inttof32(10), //position Y
					lookY + DISTANCE * floattof32((float)sin(angle*M_PI/180)), //position Z
					
					lookX, inttof32(0), lookY, //objectif
					inttof32(0), inttof32(1), inttof32(0)); //verticale
	//glTranslatef(-1, 0, 0);
	
	
	for(y = 0; y < carte.sY; y++)
	{
		for(x = 0; x < carte.sX; x++)
		{
			glBegin(GL_QUADS);
				if(carte.map[y * carte.sX + x] < 14)
				{
					glColor3f(1, 0, 0);
					
					glVertex3f(0,	carte.map[y * carte.sX + x] - 7,	1);
					glVertex3f(1,	carte.map[y * carte.sX + x] - 7,	1);
					glVertex3f(1,	carte.map[y * carte.sX + x] - 7,	0);
					glVertex3f(0,	carte.map[y * carte.sX + x] - 7,	0);
				}
				
				if(carte.map[y * carte.sX + x] > 0)
				{
					glColor3f(1, 1, 0.5); //murs en jaune
					
					if(y > 0 && carte.map[(y - 1) * carte.sX + x] < carte.map[y * carte.sX + x])
					{
						glVertex3f(0,	carte.map[y * carte.sX + x] - 7,	0);
						glVertex3f(1,	carte.map[y * carte.sX + x] - 7,	0);
						glVertex3f(1,	-7,									0);
						glVertex3f(0,	-7,									0);
					}
					if(x > 0 && carte.map[y * carte.sX + (x - 1)] < carte.map[y * carte.sX + x])
					{
						glVertex3f(0,	carte.map[y * carte.sX + x] - 7,	1);
						glVertex3f(0,	carte.map[y * carte.sX + x] - 7,	0);
						glVertex3f(0,	-7,									0);
						glVertex3f(0,	-7,									1);
					}
					if(y < carte.sY - 1 && carte.map[(y + 1) * carte.sX + x] < carte.map[y * carte.sX + x])
					{
						glVertex3f(1,	carte.map[y * carte.sX + x] - 7,	1);
						glVertex3f(0,	carte.map[y * carte.sX + x] - 7,	1);
						glVertex3f(0,	-7,									1);
						glVertex3f(1,	-7,									1);
					}
					if(x < carte.sX - 1 && carte.map[y * carte.sX + (x + 1)] < carte.map[y * carte.sX + x])
					{
						glVertex3f(1,	carte.map[y * carte.sX + x] - 7,	0);
						glVertex3f(1,	carte.map[y * carte.sX + x] - 7,	1);
						glVertex3f(1,	-7,									1);
						glVertex3f(1,	-7,									0);
					}
				}
			glEnd();
			
			glTranslatef(1, 0, 0);
		}
			
		for(u8 i = carte.sX / 7; i > 0; i--)
			glTranslatef(-7, 0, 0);
		
		glTranslatef(-(carte.sX % 7), 0, 1);
	}


return TRUE;
}


void LoadWorld()
{
	FILE* fichier = fopen("map.txt", "r");
	
		fread(&carte.sX, 1, 1, fichier);
		fread(&carte.sY, 1, 1, fichier);
		
			carte.map = (u8*)malloc(carte.sX * carte.sY);
		
		fread(carte.map, 1, carte.sX * carte.sY, fichier);
	
	fclose(fichier);
}

